<!DOCTYPE html>
<html lang="en">

<head>
    <title>Task 29.60</title>
    <meta charset="UTF-8">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

</head>

<body onload="onPageLoading()">
    <div class="container">
        <h1>Danh sách người dùng đăng ký</h1>
        <table id="table-user" class="table table-hover table-striped table-bordered">
            <thead class="thead-light">
                <tr>
                    <th>Mã người dùng</th>
                    <th>Firstname</th>
                    <th>Lastname</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>CustomerType</th>
                    <th>RegiserStatus</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>

<script>
    "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gEND_OF_ROW_COL = -1;
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-register-java-api/users";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //Hàm xử lý sự kiện loading
    function onPageLoading() {
        "use strict"
        //gọi API
        var vXHTMLRequest = new XMLHttpRequest();
        callAPI(vXHTMLRequest);
        vXHTMLRequest.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                loadDataOnTable(vXHTMLRequest);
                chiTietClick();
                console.log(vXHTMLRequest.responseText)
            }
        };
    }
    //Hàm xử lý sự kiện click

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //Hàm gọi API
    function callAPI(paramXmlHttp) {
        paramXmlHttp.open("GET", gBASE_URL, true);
        paramXmlHttp.send();
    }
    //Load dữ liệu vào table
    function loadDataOnTable(paramXmlHttp) {
        "use strict"
        // chuyển chuỗi JSON
        var vResponse = JSON.parse(paramXmlHttp.responseText);
        var vTable = document.getElementById("table-user");
        var vTableTBody = document.getElementsByTagName("tbody")[0];
        for (var bI = 0; bI < vResponse.length; bI++) {
            //tạo dòng mới 
            var vNewRow = vTableTBody.insertRow(gEND_OF_ROW_COL);
            //Tạo ô mới
            var vCellMaNguoiDung = vNewRow.insertCell(gEND_OF_ROW_COL);
            var vCellFirstName = vNewRow.insertCell(gEND_OF_ROW_COL);
            var vCellLastName = vNewRow.insertCell(gEND_OF_ROW_COL);
            var vCellCountry = vNewRow.insertCell(gEND_OF_ROW_COL);
            var vCellSubject = vNewRow.insertCell(gEND_OF_ROW_COL);
            var vCellCustomerType = vNewRow.insertCell(gEND_OF_ROW_COL);
            var vCellRegiserStatus = vNewRow.insertCell(gEND_OF_ROW_COL);
            var vCellAction = vNewRow.insertCell(gEND_OF_ROW_COL);

            //Đổ dữ liệu vào ô
            vCellMaNguoiDung.innerHTML = vResponse[bI].id;
            vCellFirstName.innerHTML = vResponse[bI].firstname;
            vCellLastName.innerHTML = vResponse[bI].lastname;
            vCellCountry.innerHTML = vResponse[bI].country;
            vCellSubject.innerHTML = vResponse[bI].subject;
            vCellCustomerType.innerHTML = vResponse[bI].customerType;
            vCellRegiserStatus.innerHTML = vResponse[bI].registerStatus;
            
            //button
            var vButton = document.createElement("button");
            vButton.className = "info-user btn btn-info";
            vButton.setAttribute("data-id", vResponse[bI].id);
            vButton.setAttribute("data-firstname", vResponse[bI].firstname);
            vButton.setAttribute("data-lastname", vResponse[bI].lastname);
            vButton.setAttribute("data-country", vResponse[bI].country);
            vButton.setAttribute("data-subject", vResponse[bI].subject);
            vButton.setAttribute("data-customer-type", vResponse[bI].customerType);
            vButton.setAttribute("data-register-status", vResponse[bI].registerStatus);
            vButton.innerHTML = "Chi Tiết";
            vCellAction.appendChild(vButton);
        }
    }
    //hàm xử lý khi ấn nút
    function chiTietClick(){
        var vButton = document.getElementsByClassName("info-user");
        for(var bI = 0; bI < vButton.length; bI++){
            vButton[bI].addEventListener('click', function(){
                onBtnChiTietClick(this);
            });
        }
    }
    //xử lý chiTietClick
    function onBtnChiTietClick(paramButton){
        var vUserId = paramButton.dataset.id;
        var vFirstName = paramButton.dataset.firstname;
        var vLastName = paramButton.dataset.lastname;
        var vCountry = paramButton.dataset.country;
        var vSubject = paramButton.dataset.subject;
        //ghi thông tin ra console
        console.log("Thông tin Chi Tiết", "color: red");
        console.log("User id: "+ vUserId);
        console.log("First name; " + vFirstName);
        console.log("Last name: " + vLastName);
        console.log("Country: " + vCountry);
        console.log("Subject: " + vSubject);
    }
</script>